package com.simuwang.daq.components.report.parser.excel;

import cn.hutool.core.collection.ListUtil;
import com.simuwang.base.mapper.EmailFieldMappingMapper;
import com.simuwang.base.pojo.dto.report.*;
import com.simuwang.daq.components.report.parser.ReportParserConstant;
import org.springframework.stereotype.Component;

import java.util.List;

@Component(ReportParserConstant.PARSER_EXCEL_MONTHLY)
public class ExcelMonthlyReportParser extends AbstractExcelReportParser<MonthlyReportData> {
    public ExcelMonthlyReportParser(EmailFieldMappingMapper fieldMappingMapper) {
        super(fieldMappingMapper);
    }

    @Override
    protected List<CustomExcelTable> customExcelTables() {
        List<CustomExcelTable> customExcelTables = ListUtil.list(true);
        customExcelTables.add(new CustomExcelTable("fundInfo", "基金概况", 4, 1, 0));
        customExcelTables.add(new CustomExcelTable("netReport", "净值月报", 5, 1, 2));
        customExcelTables.add(new CustomExcelTable("netReport", "级基金净值表", 5, 1, 2));
        return customExcelTables;
    }

    @Override
    protected MonthlyReportData parseExtInfoAndSetData(ReportBaseInfoDTO reportInfo, ReportFundInfoDTO reportFundInfo, List<SimpleTable> tables) {
        return null;
    }

    @Override
    protected ReportFundInfoDTO buildFundInfo(ReportParserParams params, List<SimpleTable> tables) {
        SimpleTable fundInfoTable = tables.stream().filter(e -> "fundInfo".equals(e.getTableKey())).findFirst().orElse(null);
        return null;
    }

    @Override
    protected void cleaningReportData(MonthlyReportData reportData) {
        // todo 数据清理
    }
}
